#---------------------------------------------------------------------------	
#	File:		StubRules.make
#
#	Contains:	Stub Make rules for building parts
#
#	Written by:	Steve Smith
#
#	Copyright:	 1995 by Apple Computer, Inc., all rights reserved.
#---------------------------------------------------------------------------	

#---------------------------------------------------------------------------	
# MAKE FAT LIBRARY
#---------------------------------------------------------------------------	

BUILDFATLIB  
	"{TargetDir}{TargetNameFat}"

"{TargetDir}{TargetNameFat}" 	"{TargetDir}{TargetNamePPCLink}" 
								"{TargetDir}{TargetNameILink}"
	end # not a typo
	if ( `exists "{TargetDir}{TargetNameILink}"` == "" || 
			`exists "{TargetDir}{TargetNamePPCLink}"` == "" )
		Echo '### Error: One or both target libraries is missing.'
		Echo '###        Please make sure both libraries are built before'
		Echo '###        executing the -fat build option.'
		Exit 0
	end
	"{MakeFat}" "{TargetDir}{TargetNameILink}" "{TargetDir}{TargetNamePPCLink}" 
			-o "{TargetDir}{TargetNameFat}"

#---------------------------------------------------------------------------	
# STUB COMPILER RULES
#---------------------------------------------------------------------------	

.cpp.o		.cpp
	Echo -n ""

.c.o		.c
	Echo -n ""

.cpp.dump 	 	.pch
	Echo -n ""

.c.dump 	 	.pch
	Echo -n ""

.xih  .idl
	Echo -n ""

.xh  .idl
	Echo -n ""

.cpp  .idl
	Echo -n ""

.ih  .idl
	Echo -n ""

.h  .idl
	Echo -n ""

.c  .idl
	Echo -n ""

.exp  .idl
	Echo -n ""
