#
#	File:		SCPCHeaders.make
#
#	Contains:	Build script for SC Precompiled Headers
#
#	Written by:	Steve Smith
#
#	Copyright:	 1995 by Apple Computer, Inc., all rights reserved.
#
#	Change History (most recent first):
#
#	To Do:
#

# --- PRECOMPILED HEADER VARIABLES ---

CPrecompiledHeaders = {ObjectsDir}SCPCHeaders.c.dump

CLoadOptions = -load "{CPrecompiledHeaders}"
CDumpOptions = -dump "{CPrecompiledHeaders}"

CppPrecompiledHeaders = {ObjectsDir}SCPCHeaders++.cpp.dump

CppLoadOptions = -load "{CppPrecompiledHeaders}"
CppDumpOptions = -dump "{CppPrecompiledHeaders}"


# --- DIRECTORY DEPENDENCIES ----

"{ObjectsDir}"  "{BuildSupportDir}"

# --- PRECOMPILED MAC HEADERS ---

MacOSIncludes = 
	"{CIncludes}Dialogs.h" 
	"{CIncludes}Errors.h" 
	"{CIncludes}Icons.h" 
	"{CIncludes}LowMem.h" 
	"{CIncludes}Menus.h" 
	"{CIncludes}Quickdraw.h" 
	"{CIncludes}Resources.h" 
	"{CIncludes}ToolUtils.h" 
	"{CIncludes}Types.h" 
	"{CIncludes}Windows.h" 

# --- SOURCE DEPENDENCIES ---

"{CPrecompiledHeaders}"		
	"{BuildSupportDir}SCPCHeaders.pch" 	
	"{ODUtilsIntfDir}Except.h"			
	"{ODUtilsIntfDir}ODDebug.h" 		
	"{ODHandMadeIntfDir}QDFixM.h"		
	"{ODHandMadeIntfDir}ODTypes.h"		
	"{ODCIntfDir}ODTypesB.h"			
	"{ODCIntfDir}GeoTypes.h"			
	"{ODCIntfDir}ODTypesM.h"			
	"{ODCIntfDir}Polygon.h"				
	"{ODCIntfDir}Part.h"				
	"{ODCIntfDir}Facet.h"				
	"{ODCIntfDir}Frame.h"				
	"{ODCIntfDir}Shape.h"				
	"{ODCIntfDir}StdProps.h"			
	"{ODCIntfDir}StdDefs.h"				
	"{ODCIntfDir}StdTypes.h"			
	"{ODCIntfDir}Draft.h"				
	"{ODCIntfDir}StorageU.h"			
	"{ODCIntfDir}Trnsform.h"			
	"{ODCIntfDir}FocusSet.h"			
	"{ODCIntfDir}MenuBar.h"				
	"{ODCIntfDir}Window.h"				
	"{ODCIntfDir}ODSessn.h"				
	{MacOSIncludes}

"{CppPrecompiledHeaders}"		
	"{BuildSupportDir}SCPCHeaders++.pch"
	"{ODUtilsIntfDir}AltPoint.h"		
	"{ODUtilsIntfDir}AltPoly.h"			
	"{ODUtilsIntfDir}Except.h"			
	"{ODUtilsIntfDir}ODDebug.h" 		
	"{ODHandMadeIntfDir}QDFixM.h"		
	"{ODHandMadeIntfDir}ODTypes.h"		
	"{ODCppIntfDir}ODTypesB.xh"			
	"{ODCppIntfDir}GeoTypes.xh"			
	"{ODCppIntfDir}ODTypesM.xh"			
	"{ODCppIntfDir}Polygon.xh"			
	"{ODCppIntfDir}Part.xh"				
	"{ODCppIntfDir}Facet.xh"			
	"{ODCppIntfDir}Frame.xh"			
	"{ODCppIntfDir}Shape.xh"			
	"{ODCppIntfDir}StdProps.xh"			
	"{ODCppIntfDir}StdTypes.xh"			
	"{ODCppIntfDir}StdDefs.xh"			
	"{ODCppIntfDir}Draft.xh"			
	"{ODCppIntfDir}StorageU.xh"			
	"{ODCppIntfDir}Trnsform.xh"			
	"{ODCppIntfDir}FocusSet.xh"			
	"{ODCppIntfDir}MenuBar.xh"			
	"{ODCppIntfDir}Window.xh"			
	"{ODCppIntfDir}ODSessn.xh"			
	"{ODUtilsIntfDir}ODMemory.h"		
	{MacOSIncludes}

