/*
	File:		EmbFrItr.cpp

	Contains:	EmbeddedFrameIterator class skeleton implementation

	Owned by:	Joshua Susser

	Copyright:	 1993 - 1995 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <3>	  8/3/95	RR		#1257260: Collapse B classes. Remove
									somInit methods. Don't call IsInitialized
									or SubclassResponsibility
		 <2>	 1/20/95	JBS		1195017, 1205669: part API changes
		 <1>	 7/20/94	JBS		first checked in
		 <0>	 7/19/94	JBS		Added SubClassResponsibility.
	To Do:
*/

#define ODEmbeddedFramesIterator_Class_Source
#include <EmbFrItr.xih>

SOM_Scope void  SOMLINK ODEmbeddedFramesIteratorInitEmbeddedFramesIterator(ODEmbeddedFramesIterator *somSelf, Environment *ev,
		ODPart* part)
{
    /* ODEmbeddedFramesIteratorData *somThis = ODEmbeddedFramesIteratorGetData(somSelf); */
    ODEmbeddedFramesIteratorMethodDebug("ODEmbeddedFramesIterator","InitEmbeddedFramesIterator");

	WARN("A subclass should have overridden this method!");
	ODSetSOMException(ev,kODErrSubClassResponsibility, "SubClass Responsibility");
}

SOM_Scope ODFrame*  SOMLINK ODEmbeddedFramesIteratorFirst(ODEmbeddedFramesIterator *somSelf, Environment *ev)
{
    /* ODEmbeddedFramesIteratorData *somThis = ODEmbeddedFramesIteratorGetData(somSelf); */
    ODEmbeddedFramesIteratorMethodDebug("ODEmbeddedFramesIterator","First");

	WARN("A subclass should have overridden this method!");
	ODSetSOMException(ev,kODErrSubClassResponsibility, "SubClass Responsibility");
	return kODNULL;
}

SOM_Scope ODFrame*  SOMLINK ODEmbeddedFramesIteratorNext(ODEmbeddedFramesIterator *somSelf, Environment *ev)
{
    /* ODEmbeddedFramesIteratorData *somThis = ODEmbeddedFramesIteratorGetData(somSelf); */
    ODEmbeddedFramesIteratorMethodDebug("ODEmbeddedFramesIterator","Next");

	WARN("A subclass should have overridden this method!");
	ODSetSOMException(ev,kODErrSubClassResponsibility, "SubClass Responsibility");
	return kODNULL;
}

SOM_Scope ODBoolean  SOMLINK ODEmbeddedFramesIteratorIsNotComplete(ODEmbeddedFramesIterator *somSelf, Environment *ev)
{
    /* ODEmbeddedFramesIteratorData *somThis = ODEmbeddedFramesIteratorGetData(somSelf); */
    ODEmbeddedFramesIteratorMethodDebug("ODEmbeddedFramesIterator","IsNotComplete");

	WARN("A subclass should have overridden this method!");
	ODSetSOMException(ev,kODErrSubClassResponsibility, "SubClass Responsibility");
	return kODFalse;
}

SOM_Scope void  SOMLINK ODEmbeddedFramesIteratorPartRemoved(ODEmbeddedFramesIterator *somSelf, Environment *ev)
{
    /* ODEmbeddedFramesIteratorData *somThis = ODEmbeddedFramesIteratorGetData(somSelf); */
    ODEmbeddedFramesIteratorMethodDebug("ODEmbeddedFramesIterator","PartRemoved");

	WARN("A subclass should have overridden this method!");
	ODSetSOMException(ev,kODErrSubClassResponsibility, "SubClass Responsibility");
}

SOM_Scope ODBoolean  SOMLINK ODEmbeddedFramesIteratorIsValid(ODEmbeddedFramesIterator *somSelf, Environment *ev)
{
    /* ODEmbeddedFramesIteratorData *somThis = ODEmbeddedFramesIteratorGetData(somSelf); */
    ODEmbeddedFramesIteratorMethodDebug("ODEmbeddedFramesIterator","IsValid");

	WARN("A subclass should have overridden this method!");
	ODSetSOMException(ev,kODErrSubClassResponsibility, "SubClass Responsibility");
	return kODFalse;
}

SOM_Scope void  SOMLINK ODEmbeddedFramesIteratorCheckValid(ODEmbeddedFramesIterator *somSelf, Environment *ev)
{
    /* ODEmbeddedFramesIteratorData *somThis = ODEmbeddedFramesIteratorGetData(somSelf); */
    ODEmbeddedFramesIteratorMethodDebug("ODEmbeddedFramesIterator","CheckValid");

	WARN("A subclass should have overridden this method!");
	ODSetSOMException(ev,kODErrSubClassResponsibility, "SubClass Responsibility");
}

SOM_Scope void  SOMLINK ODEmbeddedFramesIteratorsomUninit(ODEmbeddedFramesIterator *somSelf)
{
    /* ODEmbeddedFramesIteratorData *somThis = ODEmbeddedFramesIteratorGetData(somSelf); */
    ODEmbeddedFramesIteratorMethodDebug("ODEmbeddedFramesIterator","somUninit");

    ODEmbeddedFramesIterator_parent_ODObject_somUninit(somSelf);
}
