/*
	File:		DraftWLD.cpp

	Contains:	Implemementation of LDEF for Drafts dialog.

	Owned by:	Eric House

	Copyright:	 1994 - 1995 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <6>	 8/25/95	eeh		1230007: don't do hilite here
		 <5>	 5/10/95	eeh		1215536: cleanup
		 <4>	 3/24/95	eeh		1229961: change callbacks to use IText*
		 <3>	12/19/94	eeh		1192626: pass in column starts; code review
									changes
		 <2>	 7/23/94	T		use DraftWLD.h
		 <1>	 6/27/94	T		first checked in
		 <0>	 6/27/94	SV		SOMverted
		 <1>	  5/3/94	eeh		first checked in (bug #1155857)

	To Do:
*/

#ifndef __LISTS__
#include <Lists.h>
#endif

#ifndef _DRAFTWLD_
#include "DraftWLD.h"
#endif

////////////////////////////////////////////////////////////////////////////////
//
//	Drafts Window LDEF
//
////////////////////////////////////////////////////////////////////////////////


pascal void DRAFTWINDOWLDEF( short lMessage, Boolean lSelect, const Rect* lRect,
		Cell lCell, short /*lDataOffset*/, short /*lDataLen*/, ListHandle lHandle )
{
	switch( lMessage )
	{
		case lInitMsg :
		case lCloseMsg :
			return ;

		case lDrawMsg :
		case lHiliteMsg :
		{
			if ( lCell.h != 0 )
				return ;

			EraseRect( lRect ) ;
			
			DraftLDEFCallbackInfo* hc =
					(DraftLDEFCallbackInfo*)(*lHandle)->refCon ;
			(*hc->stringsProc)( hc, lCell.v, lRect );
/*
			if ( lSelect )
			{
				short oldPenMode = (*lHandle)->port->pnMode;
				PenMode( hilitetransfermode );
				PaintRect( lRect ) ;
				PenMode( oldPenMode );
			}
*/
			break ;
		}
	}
}	// DRAFTWINDOWLDEF
