/*
	File:		DraftWLD.h

	Contains:	header for LDEF for Drafts dialog.

	Owned by:	Eric House

	Copyright:	 1994 - 1995 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <6>	 9/29/95	eeh		1287262: use ShellDef.h
		 <5>	 8/25/95	eeh		1230007: add arrowEnds
		 <4>	 3/24/95	eeh		1229961: change callbacks to use IText*
		 <3>	12/19/94	eeh		1192626: pass in column starts
		 <2>	 8/18/94	T		#1181622 Removed my name from the Written
									By: field
		 <1>	 7/23/94	T		first checked in
	To Do:
*/

#ifndef _DRAFTWLD_
#define _DRAFTWLD_

#ifndef __TYPES__
#include <Types.h>
#endif

#ifndef _SHELLDEF_
#include "ShellDef.h"
#endif

#ifndef _DRAFTWN_
#include "DraftWn.h"
#endif

struct DWStringsArray {
	Str255 creator;
	Str255 draft;
	Str255 created;
	Str255 comment;
};
typedef struct DWStringsArray DWStringsArray;

//typedef	ODBoolean (*GetDWUserStringProc)( DraftInfoRec *self, ODSShort row,
//		DWStringsArray* theStrings);

typedef	void (*DrawDWUserStringsProc)( struct DraftLDEFCallbackInfo *callbackInfo,
		ODSShort row, const Rect* listItemRect);

struct DraftLDEFCallbackInfo {
	DialogPtr dialog;
	DraftInfoRec *dir;
	DrawDWUserStringsProc stringsProc;
	struct {
		short right;
		short left;
		} rectEnds[4];
	struct {
		short right;
		short left;
		} arrowEnds;
};
typedef struct DraftLDEFCallbackInfo DraftLDEFCallbackInfo;

pascal void DRAFTWINDOWLDEF( short lMessage, Boolean lSelect, const Rect* lRect,
		Cell lCell, short /*lDataOffset*/, short /*lDataLen*/, ListHandle lHandle );


#endif // _DRAFTWLD_