/*
	File:		ODTestMn.r

	Contains:	resources for ODTestMain to enable you to drop documents onto it

	Owned by:	Tantek elik

	Copyright:	 1994 - 1995 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <4>	 10/3/95	eeh		1287262: include ShellDef.h
		 <3>	 1/10/95	eeh		1196515 for jpa: SOMCustomMemoryMgr
									fragments
		 <2>	  1/6/95	jpa		Added SIZE/cfrg/scsz resources [1196515]
		 <1>	 8/19/94	T		first checked in
					#1159233 Remove references to j3di
	To Do:
*/

#define SystemSevenOrBetter 1			// we want the extended types
#define	SystemSevenOrLater	1			// Types.r uses this variable

#ifndef __TYPES_R__
#include "Types.r"
#endif

#ifndef __SYSTYPES_R__
#include "SysTypes.r"
#endif

#ifndef __AEWIDEUSERTERMTYPES__
#include "AEUserTermTypes.r"
#endif

#ifndef __CODEFRAGMENTTYPES__
#include "CodeFragmentTypes.r"
#endif

#ifndef _SHELLDEF_
#include "ShellDef.h"
#endif

 
//-------------------------------------------------------------------------------------
// SIZE Resource
// Size -1 resource for all OpenDoc documents
//-------------------------------------------------------------------------------------

 RESOURCE 'SIZE' (-1) {
	reserved,
	acceptSuspendResumeEvents,
	reserved,
	canBackground,
	doesActivateOnFGSwitch,
	backgroundAndForeground,
	dontGetFrontClicks,
	acceptChildDiedEvents,		// necessary in case "New" command fails to launch doc
	is32BitCompatible,
	isHighLevelEventAware,
	localAndRemoteHLEvents,
	isStationeryAware,
	dontUseTextEditServices,
	reserved,
	reserved,
	reserved,
	1000 * 1024,	
	1000 * 1024
};

//-------------------------------------------------------------------------------------
// scsz resource for AppleScript
//-------------------------------------------------------------------------------------

resource 'scsz' (kscszID) {		// <eeh> was 129, but that didn't seem to work
	readExtensionTerms,		// was dontReadExtensionTerms; why?
	findAppBySignature,
	alwaysSendSubject,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	8,
	8,
	8,
	368640,
	368640,
	368640
};


//-------------------------------------------------------------------------------------
// Code-fragment resource (cfrg)
//-------------------------------------------------------------------------------------

resource 'cfrg' (kcfrgID) {
	{	/* array memberArray: 4 elements */
		/* [1] */
		kPowerPC,
		kFullLib,
		kNoVersionNum,
		kNoVersionNum,
		262144,				/* was kDefaultStackSize */
		kNoAppSubFolder,
		kIsApp,
		kOnDiskFlat,
		kZeroOffset,
		kWholeFork,
		"ODTestMain",
		
		/* [2] */
		kMotorola,
		kFullLib,
		kNoVersionNum,
		kNoVersionNum,
		262144,				/* was kDefaultStackSize */
		kNoAppSubFolder,
		kIsApp,
		kOnDiskSegmented,
		kMainCFMType,
		kMainCFM68KID,
		"ODTestMain",
		
		/* [3] SOMCustomMemoryMgr PPC lib */
		kPowerPC,
		kFullLib,
		0, 					/*Erik sez use 1, but that doesn't work*/
		kNoVersionNum,
		4096,				/* was kDefaultStackSize */
		kNoAppSubFolder,
		kIsLib,
		kOnDiskSegmented,
		'rseg',
		4,
		"SOMCustomMemoryMgr",
		
		/* [4] SOMCustomMemoryMgr 68k lib  */
		kMotorola,
		kFullLib,
		0, 					/*Erik sez use 1, but that doesn't work*/
		kNoVersionNum,
		4096,				/* was kDefaultStackSize */
		kNoAppSubFolder,
		kIsLib,
		kOnDiskSegmented,
		'rseg',
		3,
		"SOMCustomMemoryMgr"
	}
};


//-------------------------------------------------------------------------------------
// SOMCustomMemoryMgr fragment
//-------------------------------------------------------------------------------------

read 'rseg' (3) "SOMMem68k";
read 'rseg' (4) "SOMMemPPC";


//-------------------------------------------------------------------------------------
// BNDL, FREF, data (Onwer Resource)
//-------------------------------------------------------------------------------------

#define kApplCrtrID		128
#define kWildCrtrID		129
#define kODTestMainSignature	'odbg'

data kODTestMainSignature (0, "Owner resource") {
	$"00"                                                 /* . */
};

resource 'FREF' (kApplCrtrID) {
	'APPL',
	0,
	""
};

resource 'FREF' (kWildCrtrID) {
	'****',
	1,
	""
};

resource 'BNDL' (kApplCrtrID) {
	kODTestMainSignature,
	0,
	{	/* array TypeArray: 2 elements */
		/* [1] */
		'FREF',
		{	/* array IDArray: 2 elements */
			/* [1] */
			0, kApplCrtrID,
			/* [2] */
			1, kWildCrtrID
		},
		/* [2] */
		'ICN#',
		{	/* array IDArray: 2 elements */
			/* [1] */
			0, kApplCrtrID,
			/* [2] */
			1, kWildCrtrID
		}
	}
};



// icons: ICN# etc.  Currently the original OpenDoc icon.

resource 'ics8' (kApplCrtrID) {
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 00FB FBFB FBFB FB00 0000 0000"
	$"0000 00FB FB16 16F8 F8FB FBFB 0000 0000"
	$"0000 FBFB 1616 16F8 F5F5 F8FB FB00 0000"
	$"0000 FB16 1616 16F8 F5F5 F5F5 FBFB 0000"
	$"00FB FB16 0116 16F8 F5F5 F5F5 F8FB 0000"
	$"00FB 1616 1616 16F8 F5F5 F5F5 F5FB FB00"
	$"00FB 1616 1616 16F8 F5F5 F5F5 F5FB FB00"
	$"00FB 1616 1616 16F8 F5F5 F5F5 F5FB FB00"
	$"00FB 1616 1616 16F8 F5F5 F5F5 F5FB FB00"
	$"00FB FB16 1616 16F8 F5F5 F5F5 FBFB 0000"
	$"0000 FB16 1616 16F8 F5F5 F5F8 FBFB 0000"
	$"0000 00FB 1616 16F8 F8F8 FBFB FB00 0000"
	$"0000 0000 FBFB 16FB FBFB FBFB 0000 0000"
	$"0000 0000 0000 FBFB FBFB"
};

resource 'ics4' (kApplCrtrID) {
	$"0000 0000 0000 0000 0000 0EEE EEE0 0000"
	$"000E E22C CEEE 0000 00EE 222C 00CE E000"
	$"00E2 222C 0000 EE00 0EE2 022C 0000 CE00"
	$"0E22 222C 0000 0EE0 0E22 222C 0000 0EE0"
	$"0E22 222C 0000 0EE0 0E22 222C 0000 0EE0"
	$"0EE2 222C 0000 EE00 00E2 222C 000C EE00"
	$"000E 222C CCEE E000 0000 EE2E EEEE 0000"
	$"0000 00EE EE"
};

resource 'ics#' (kApplCrtrID) {
	{	/* array: 2 elements */
		/* [1] */
		$"0000 07E0 1870 3018 200C 6004 4006 4006"
		$"4006 4006 600C 200C 1038 0DF0 03C0",
		/* [2] */
		$"0000 07E0 1FF0 3FF8 3FFC 7FFC 7FFE 7FFE"
		$"7FFE 7FFE 7FFC 3FFC 1FF8 0FF0 03C0"
	}
};

resource 'ICN#' (kApplCrtrID) {
	{	/* array: 2 elements */
		/* [1] */
		$"0000 0000 0000 0000 000F E000 003F F800"
		$"00F0 1E00 01C0 0700 0300 0180 0600 00C0"
		$"0C00 0060 0C00 0020 1800 0030 1800 0010"
		$"3000 0018 3000 0018 3000 0018 3000 0018"
		$"3000 0018 3000 0018 3000 0018 1800 0010"
		$"1800 0030 0C00 0060 0C00 0060 0600 00C0"
		$"0300 0180 01C0 0700 00F0 1E00 003F F800"
		$"000F E0",
		/* [2] */
		$"0000 0000 0000 0000 000F E000 003F F800"
		$"00FF FE00 01FF FF00 03FF FF80 07FF FFC0"
		$"0FFF FFE0 0FFF FFE0 1FFF FFF0 1FFF FFF0"
		$"3FFF FFF8 3FFF FFF8 3FFF FFF8 3FFF FFF8"
		$"3FFF FFF8 3FFF FFF8 3FFF FFF8 1FFF FFF0"
		$"1FFF FFF0 0FFF FFE0 0FFF FFE0 07FF FFC0"
		$"03FF FF80 01FF FF00 00FF FE00 003F F800"
		$"000F E0"
	}
};

resource 'icl8' (kApplCrtrID) {
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 FBFB FBFB"
	$"FBFB FB00 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 FBFB FBFB FBFB"
	$"FBFB FBFB FB00 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 FBFB FBFB 1605 F8F8"
	$"F8F8 F8FB FBFB FB00 0000 0000 0000 0000"
	$"0000 0000 0000 00FB FBFB 0516 0516 F8F8"
	$"F8F8 F8F8 F8FB FBFB 0000 0000 0000 0000"
	$"0000 0000 0000 FBFB 1605 0505 1605 F8F8"
	$"F8F8 F8F8 F8F8 F8FB FB00 0000 0000 0000"
	$"0000 0000 00FB FB05 0516 0516 0516 F8F8"
	$"F8F5 F5F5 F8F8 F8F8 FBFB 0000 0000 0000"
	$"0000 0000 FBFB 1605 1605 1605 0505 F8F8"
	$"F8F5 F5F5 F5F5 F8F8 F8FB FB00 0000 0000"
	$"0000 0000 FBFB 0516 0101 0116 0516 F8F8"
	$"F8F5 F5F5 F5F5 F5F8 F8F8 FB00 0000 0000"
	$"0000 00FB FB05 1605 0101 0105 1605 F8F8"
	$"F8F5 F5F5 F5F5 F5F5 F8F8 FBFB 0000 0000"
	$"0000 00FB FB05 0516 0101 0116 0516 F8F8"
	$"F8F5 F5F5 F5F5 F5F5 F8F8 F8FB 0000 0000"
	$"0000 FBFB 1605 1605 1605 1605 0505 F8F8"
	$"F8F5 F5F5 F5F5 F5F5 F5F8 F8FB FB00 0000"
	$"0000 FBFB 0516 0505 0516 0516 0516 F8F8"
	$"F8F5 F5F5 F5F5 F5F5 F5F8 F8FB FB00 0000"
	$"0000 FBFB 1605 1605 1605 0505 1605 F8F8"
	$"F8F5 F5F5 F5F5 F5F5 F5F8 F8FB FB00 0000"
	$"0000 FBFB 0516 0516 0516 0516 0516 F8F8"
	$"F8F5 F5F5 F5F5 F5F5 F5F8 F8FB FB00 0000"
	$"0000 FBFB 1605 1605 1605 1605 1605 F8F8"
	$"F8F5 F5F5 F5F5 F5F5 F5F8 F8FB FB00 0000"
	$"0000 FBFB 0516 0516 0516 0516 0516 F8F8"
	$"F8F5 F5F5 F5F5 F5F5 F5F8 F8FB FB00 0000"
	$"0000 FBFB 1605 1605 1605 1605 1605 F8F8"
	$"F8F5 F5F5 F5F5 F5F5 F5F8 F8FB FB00 0000"
	$"0000 00FB FB16 0516 0516 0516 0516 F8F8"
	$"F8F5 F5F5 F5F5 F5F5 F8F8 F8FB 0000 0000"
	$"0000 00FB FB05 1605 1605 1605 1605 F8F8"
	$"F8F5 F5F5 F5F5 F5F5 F8F8 FBFB 0000 0000"
	$"0000 0000 FBFB 0516 0516 0516 0516 F8F8"
	$"F8F5 F5F5 F5F5 F5F8 F8FB FB00 0000 0000"
	$"0000 0000 FBFB 1605 1605 1605 1605 F8F8"
	$"F8F5 F5F5 F5F5 F8F8 F8FB FB00 0000 0000"
	$"0000 0000 00FB FB16 0516 0516 0516 F8F8"
	$"F8F5 F5F5 F8F8 F8F8 FBFB 0000 0000 0000"
	$"0000 0000 0000 FBFB 1605 1605 1605 F8F8"
	$"F8F8 F8F8 F8F8 F8FB FB00 0000 0000 0000"
	$"0000 0000 0000 00FB FBFB 0516 0516 F8F8"
	$"F8F8 F8F8 F8FB FBFB 0000 0000 0000 0000"
	$"0000 0000 0000 0000 FBFB FBFB 1605 F8F8"
	$"F8F8 F8FB FBFB FB00 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 FBFB FBFB FBFB"
	$"FBFB FBFB FB00 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 FBFB FBFB"
	$"FBFB FB"
};

resource 'icl4' (kApplCrtrID) {
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 0000 0000 0000 0000 0000"
	$"0000 0000 0000 EEEE EEE0 0000 0000 0000"
	$"0000 0000 00EE EEEE EEEE E000 0000 0000"
	$"0000 0000 EEEE 21CC CCCE EEE0 0000 0000"
	$"0000 000E EE12 12CC CCCC CEEE 0000 0000"
	$"0000 00EE 2111 21CC CCCC CCCE E000 0000"
	$"0000 0EE1 1212 12CC C000 CCCC EE00 0000"
	$"0000 EE21 2121 11CC C000 00CC CEE0 0000"
	$"0000 EE12 0002 12CC C000 000C CCE0 0000"
	$"000E E121 0001 21CC C000 0000 CCEE 0000"
	$"000E E112 0002 12CC C000 0000 CCCE 0000"
	$"00EE 2121 2121 11CC C000 0000 0CCE E000"
	$"00EE 1211 1212 12CC C000 0000 0CCE E000"
	$"00EE 2121 2111 21CC C000 0000 0CCE E000"
	$"00EE 1212 1212 12CC C000 0000 0CCE E000"
	$"00EE 2121 2121 21CC C000 0000 0CCE E000"
	$"00EE 1212 1212 12CC C000 0000 0CCE E000"
	$"00EE 2121 2121 21CC C000 0000 0CCE E000"
	$"000E E212 1212 12CC C000 0000 CCCE 0000"
	$"000E E121 2121 21CC C000 0000 CCEE 0000"
	$"0000 EE12 1212 12CC C000 000C CEE0 0000"
	$"0000 EE21 2121 21CC C000 00CC CEE0 0000"
	$"0000 0EE2 1212 12CC C000 CCCC EE00 0000"
	$"0000 00EE 2121 21CC CCCC CCCE E000 0000"
	$"0000 000E EE12 12CC CCCC CEEE 0000 0000"
	$"0000 0000 EEEE 21CC CCCE EEE0 0000 0000"
	$"0000 0000 00EE EEEE EEEE E000 0000 0000"
	$"0000 0000 0000 EEEE EEE0"
};

