/*
	File:		ShelAETE.r

	Contains:	AETE resources for the document shell

	Owned by:	Eric House

	Copyright:	 1993 - 1995 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		<12>	 8/25/95	JP		1272288: Removed OpenDoc suite
		<11>	 6/13/95	JP		Recordable Clock
		<10>	  6/9/95	TJ		Include ODRgstry.r instead of ODRgstry.xh
		 <9>	 4/28/95	eeh		(for eeh) 1243352: un-commented out
									pContainer
		 <8>	 4/25/95	JP		1192027: Removed some properties from parts
		 <7>	 3/21/95	JP		1192027: Include ODRgstry & revamp aete
		 <6>	  3/8/95	eeh		1226897: nuke drafts
		 <5>	 2/21/95	eeh		1214783: add constants for KeyForms and
									properties
		 <4>	  2/3/95	eeh		1214783: added part/frame properties and
									enums
		 <3>	 1/25/95	eeh		1214783: add "is frozen" property of
									parts/frames
		 <2>	10/10/94	NP		1192027-Add revert to shell's aete.
		 <1>	 7/13/94	T		first checked in
		 <0>	 6/27/94	SV		SOMverted
		 <7>	 3/24/94	eeh		bug# 1151750: added plural forms of draft,
									frame and part
		 <6>	 3/16/94	RR		#1151152 Fixed spelling mistake "singlular"
		 <5>	 1/29/94	NP		Removed reference to Exemplar.
		 <4>	 12/9/93	eeh		didn't need AEObjects.r either
		 <3>	 12/9/93	eeh		removed #include AppleEvents.r
		 <2>	 12/9/93	eeh		Added "Frame"; other scripting tweaks
		 <1>	 11/12/93	eeh		First Checked In.

*/

#ifndef __AEUSERTERMTYPES__
#include "AEUserTermTypes.r"
#endif

#ifndef __APPLEEVENTS_R__
#include "AppleEvents.r"
#endif

#ifndef __AEOBJECTS_R__
#include "AEObjects.r"
#endif

#ifndef __AEREGISTRY.R__
#include "AERegistry.r"
#endif

#ifndef __ODREGISTRY__
#include "ODRgstry.r"
#endif

#define reserved3	reserved,\
					reserved,\
					reserved

#define reserved8	reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved

#define reserved9	reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved

#define reserved11	reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved

#define reserved12	reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved

#define reserved13	reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved

#define pInherited	'c@#^'
#define english 0

resource kAETerminologyExtension (english) {
	0x1,
	0x0,
	english,
	roman,
	{	/* array Suites: 3 elements */
		/* [1] */
		"",
		"",
		kAERequiredSuite,
		1,
		1,
		{	/* array Events: 0 elements */
		},
		{	/* array Classes: 0 elements */
		},
		{	/* array ComparisonOps: 0 elements */
		},
		{	/* array Enumerations: 0 elements */
		},
		/* [2] */
		"",
		"",
		kAEMiscStandards,
		1,
		1,
		{	/* array Events: 0 elements */
			/* [11] */
			"revert",
			"Restore the document to its last saved state",
			kAEMiscStandards,
			kAERevert,
			noReply,
			"",
			replyOptional,
			singleItem,
			notEnumerated,
			reserved13,
			typeObjectSpecifier,
			"The object to revert",
			directParamRequired,
			singleItem,
			notEnumerated,
			changesState,
			reserved12,
			{	/* array OtherParams: 0 elements */
			},
		},
		{	/* array Classes: 0 elements */
		},
		{	/* array ComparisonOps: 0 elements */
		},
		{	/* array Enumerations: 0 elements */
		},
	}
};
