/*
	File:		Matrix.h

	Contains:	Matrix math [private] for ODTransforms.

	Owned by:	Jens Alfke (conversion to OpenDoc)
	Written by:	Based on QuickDraw GX code by Cary Clark, Michael Fairman,
				Robert Johnson, Keith McGreggor, Oliver Steele, David Van Brink

	Copyright:	 1987-1994 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):
	
		 <1>	 6/15/94	jpa		first checked in
		 ---------------------------Moved to ODSOM project.
		 <1>	  5/9/94	jpa		first checked in
	To Do:
*/


#ifndef _MATRIX_
#define _MATRIX_

#ifndef _ODTYPES_
#include "ODTypes.h"
#endif


extern const ODMatrix kODIdentityMatrix;


ODTransformType MxType( const ODMatrix* );

ODBoolean	MxNormalize( ODMatrix* );
ODBoolean	MxInverse( const ODMatrix*, register ODTransformType,
					   ODMatrix *imatrix);
ODBoolean	MxMul( const ODMatrix*, ODTransformType,
				   ODPoint *vector, ODSLong cnt);
ODBoolean	MxConcat( const ODMatrix *a, ODTransformType aFlags,
					  ODMatrix *b, ODTransformType bFlags );		// b = b * a
ODBoolean	MxMove( ODMatrix*, ODTransformType, ODFixed tx, ODFixed ty );
ODBoolean	MxMoveTo( ODMatrix*, ODTransformType, ODFixed x, ODFixed y);
ODBoolean	MxScale( ODMatrix*, ODFixed sx, ODFixed sy);
ODBoolean	MxSkew( ODMatrix*, ODFixed sx, ODFixed sy);
ODBoolean	MxRotate( ODMatrix*, ODFixed angle );


#endif /*_MATRIX_*/
