/*
	File:		FacetNod.cpp

	Contains:	Implementation of class FacetNode

	Owned by:	Joshua Susser

	Copyright:	 1993 - 1995 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <2>	 5/26/95	RR		#1251403: Multithreading naming support
		 <1>	 6/29/94	JBS		first checked in
		 <0>	 6/29/94	SV		SOMverted
		 <1>	 3/11/94	JBS		first checked in
		 <2>	11/12/93	JBS		use Facets
		 <1>	 9/23/93	JBS		first checked in
*/

#ifndef _FACETNOD_
#include "FacetNod.h"
#endif

#pragma segment ODFacet

//=====================================================================================
// Class FacetNode 
//=====================================================================================

//------------------------------------------------------------------------------
// FacetNode::FacetNode
//------------------------------------------------------------------------------

FacetNode::FacetNode(ODFacet* facet) : Node()
{
	fFacet = facet;
}
			
//------------------------------------------------------------------------------
// FacetNode::~FacetNode
//------------------------------------------------------------------------------

FacetNode::~FacetNode()
{
}						

//------------------------------------------------------------------------------
// FacetNode::AcquireFrame
//------------------------------------------------------------------------------

ODFacet* FacetNode::GetFacet()				
{ 
	return fFacet;
}
		
