/*
	File:		FacetNod.h

	Contains:	Definition of class FacetNode

	Written by:	Joshua Susser

	Copyright:	 1992-94 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <1>	 6/29/94	JBS		first checked in
		 <0>	 6/29/94	SV		SOMverted
		 <2>	 3/15/94	MB		Changes to support SCpp/ASLM builds,
									#1150864.
		 <1>	 3/11/94	JBS		first checked in
		 <3>	  2/3/94	JA		Tiger Team Makeover!
		 <2>	11/12/93	JBS		use Facets
		 <1>	 9/23/93	JBS		first checked in
*/

#ifndef _FACETNOD_
#define _FACETNOD_

#ifndef _PLFMDEF_
#include "PlfmDef.h"
#endif

#ifndef _ODTYPES_
#include <ODTypes.h>
#endif

#ifndef _NODE_
#include "Node.h"
#endif

//==============================================================================
// Theory of Operation
//==============================================================================

/*

FacetNode-s stitch Facet-s together into a tree structure.  Each Facet has a 
FacetNode which holds its place in the visible frame structure for the document.

*/

//=====================================================================================
// Classes defined in this interface
//=====================================================================================

class FacetNode;

//=====================================================================================
// Classes used by this interface
//=====================================================================================

class Node;
class ODFacet;

//=====================================================================================
// FacetNode
//=====================================================================================

class FacetNode : public Node
{

public:
	
	FacetNode(ODFacet* facet);
		
	ODVMethod ~  FacetNode();
	
	ODVMethod ODFacet* GetFacet();

private:

	ODFacet* fFacet;
};

#endif // _FACETNOD_