/*
	File:		ODAETE.r

	Contains:	AETE resources for the OpenDoc

	Owned by:	Jon Pugh

	Copyright:	 1993 - 1995 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <2>	 9/19/95	JP		1285737: Renumber OpenDoc aete
		 <1>	 8/25/95	JP		first checked in

*/

#ifndef __AEUSERTERMTYPES__
#include "AEUserTermTypes.r"
#endif

#ifndef __APPLEEVENTS_R__
#include "AppleEvents.r"
#endif

#ifndef __AEOBJECTS_R__
#include "AEObjects.r"
#endif

#ifndef __AEREGISTRY.R__
#include "AERegistry.r"
#endif

#ifndef __ODREGISTRY__
#include "ODRgstry.r"
#endif

#define reserved3	reserved,\
					reserved,\
					reserved

#define reserved8	reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved

#define reserved9	reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved

#define reserved11	reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved

#define reserved12	reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved

#define reserved13	reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved,\
					reserved

#define pInherited	'c@#^'
#define english 0

/*
 *	We're number the OpenDoc aetes as -1-language (-1 and down) 
 *	so we can seperate the shell from the messaging aetes.  The shell
 *	aetes are numbered normally (0 and up)
 */
resource kAETerminologyExtension (-1-english) {
	0x1,
	0x0,
	english,
	roman,
	{	/* array Suites: 1 elements */
		/* [1] */
		"OpenDoc Suite",
		"Objects that OpenDoc supports.",
		kAEOpenDocSuite,
		1,
		0,
		{	/* array Events: 0 elements */
		},
		{	/* array Classes: 7 elements */
			/* [1] */
			"application",
			cApplication,
			"The document containing the parts.",
			{	/* array Properties: 1 elements */
				/* [1] */
				"<inherited>",
				pInherited,
				cPart,
				"This is the root part of the document.",
				reserved,
				singleItem,
				notEnumerated,
				readWrite,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
			},
			{	/* array Elements: 1 elements */
				/* [1] */
				cPart,
				{	/* array KeyForms: 4 elements */
					formAbsolutePosition, formName, formUniqueID, formTest
				}
			},
			/* [2] */
			"part",
			cPart,
			"Part editors and part viewers along with their content data.",
			{	/* array Properties: 19 elements */
				/* [1] */
				"author",
				pAuthor,
				cIntlText,
				"The part's author.",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [2] */
				"best type",
				pBestType,
				cType,
				"The best descriptor type available.",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [3] */
				"bundled",
				pBundled,
				cBoolean,
				"Indicates the part is bundled into a single item.",
				reserved,
				singleItem,
				notEnumerated,
				readWrite,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [4] */
				"category",
				pCategory,
				cIntlText,
				"The part's category.",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [5] */
				"class",
				pClass,
				cType,
				"The class of this part.",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [6] */
				"comment",
				pComment,
				cIntlText,
				"Comments about this part.",
				reserved,
				singleItem,
				notEnumerated,
				readWrite,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [7] */
				"container",
				pContainer,
				cPart,
				"The part which contains this part.",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [8] */
				"creation date",
				pASCreationDate,
				cLongDateTime,
				"The part's creation date.",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [9] */
				"default type",
				pDefaultType,
				cType,
				"The default descriptor type for the part.",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [10] */
				"editor",
				pEditorName,
				cIntlText,
				"The part editor's name.",
				reserved,
				singleItem,
				notEnumerated,
				readWrite,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [11] */
				"icon",
				pIcon,
				cIconFamily,
				"The icon representing this part.",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [12] */
				"id",
				pUniqueID,
				cLongInteger,
				"The part's unique ID.",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [13] */
				"kind",
				pKind,
				cIntlText,
				"The part type.",
				reserved,
				singleItem,
				notEnumerated,
				readWrite,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [14] */
				"modification date",
				pASModificationDate,
				cLongDateTime,
				"The part's most recent modification date.",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [15] */
				"name",
				pName,
				cIntlText,
				"The name of the part.",
				reserved,
				singleItem,
				notEnumerated,
				readWrite,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [16] */
				"show links",
				pShowLinks,
				cBoolean,
				"Indicates the part is showing its links.",
				reserved,
				singleItem,
				notEnumerated,
				readWrite,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [17] */
				"part size",
				pSize,
				cLongInteger,
				"The part's size on disk.",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [18] */
				"stationery",
				pStationery,
				cBoolean,
				"Whether this part is stationary.",
				reserved,
				singleItem,
				notEnumerated,
				readWrite,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [19] */
				"view type",
				pViewType,
				enumViewType,
				"How to view this part.",
				reserved,
				singleItem,
				notEnumerated,
				readWrite,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
			},
			{	/* array Elements: 1 elements */
				/* [1] */
				cPart,
				{	/* array KeyForms: 4 elements */
					formAbsolutePosition, formName, formUniqueID, formTest
				}
			},
			/* [2] */
			"parts",
			cPart,
			"Every part.",
			{	/* array Properties: 1 elements */
				/* [1] */
				"",
				kAESpecialClassProperties,
				cType,
				"",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				plural,
			},
			{	/* array Elements: 0 elements */
			},
#if 0
			/* [3] */
			"draft",
			cDraft,
			"Named versions of a document.",
			{	/* array Properties: 9 elements */
				/* [1] */
				"author",
				pAuthor,
				cIntlText,
				"The draft's author.",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [2] */
				"best type",
				pBestType,
				cType,
				"The best descriptor type for the draft.",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [3] */
				"class",
				pClass,
				cType,
				"The class of the draft.",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [4] */
				"comment",
				pComment,
				cIntlText,
				"Comments about this draft.",
				reserved,
				singleItem,
				notEnumerated,
				readWrite,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [5] */
				"creation date",
				pASCreationDate,
				cLongDateTime,
				"The draft's creation date.",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [6] */
				"default type",
				pDefaultType,
				cType,
				"The default type for the draft.",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [7] */
				"index",
				pIndex,
				cLongInteger,
				"The number of this draft.",
				reserved,
				singleItem,
				notEnumerated,
				readWrite,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [8] */
				"name",
				pName,
				cIntlText,
				"The name of this draft.",
				reserved,
				singleItem,
				notEnumerated,
				readWrite,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [9] */
				"size",
				pSize,
				cLongInteger,
				"The draft's size on disk.",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
			},
			{	/* array Elements: 1 elements */
				cPart,
				{	/* array KeyForms: 4 elements */
					formAbsolutePosition, formName, formUniqueID, formTest
				}
			},
			/* [4] */
			"drafts",
			cDraft,
			"Every draft.",
			{	/* array Properties: 1 elements */
				/* [1] */
				"",
				kAESpecialClassProperties,
				cType,
				"",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				plural,
			},
			{	/* array Elements: 0 elements */
			},
			/* [5] */
			"window",
			cWindow,
			"A window which has a part embedded in it.",
			{	/* array Properties: 16 elements */
				/* [1] */
				"<inherited>",
				pInherited,
				cPart,
				"This is the root part of the document.",
				reserved,
				singleItem,
				notEnumerated,
				readWrite,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [2] */
				"best type",
				pBestType,
				cType,
				"The best descriptor type for the window.",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [3] */
				"bounds",
				pBounds,
				cQDRectangle,
				"The boundary rectangle for the window.",
				reserved,
				singleItem,
				notEnumerated,
				readWrite,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [4] */
				"class",
				pClass,
				cType,
				"The class of the window.",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [5] */
				"closable",
				pHasCloseBox,
				cBoolean,
				"Specifies whether the window has a close box.",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [6] */
				"default type",
				pDefaultType,
				cType,
				"The default descriptor type for the window.",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [7] */
				"floating",
				pIsFloating,
				cBoolean,
				"Specifies whether the window is a floating window.",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [8] */
				"index",
				pIndex,
				cLongInteger,
				"The number of the window.",
				reserved,
				singleItem,
				notEnumerated,
				readWrite,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [9] */
				"modal",
				pIsModal,
				cBoolean,
				"Specifies whether the window is modal.",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [10] */
				"name",
				pName,
				cIntlText,
				"The name of the window.",
				reserved,
				singleItem,
				notEnumerated,
				readWrite,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [11] */
				"resizable",
				pIsResizable,
				cBoolean,
				"Specifies whether the window is resizable.",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [12] */
				"selection",
				pSelection,
				cSelection,
				"The current user selection for the window.",
				reserved,
				singleItem,
				notEnumerated,
				readWrite,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [13] */
				"titled",
				pHasTitleBar,
				cBoolean,
				"Specifies whether the window has a title bar.",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [14] */
				"visible",
				pVisible,
				cBoolean,
				"Specifies whether the window is visible.",
				reserved,
				singleItem,
				notEnumerated,
				readWrite,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [15] */
				"zoomable",
				pIsZoomable,
				cBoolean,
				"Specifies whether the window can be zoomed.",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular,
				/* [16] */
				"zoomed",
				pIsZoomed,
				cBoolean,
				"Specifies whether the window is full size.",
				reserved,
				singleItem,
				notEnumerated,
				readWrite,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				singular
			},
			{	/* array Elements: 1 elements */
				/* [1] */
				cPart,
				{	/* array KeyForms: 4 elements */
					formAbsolutePosition, formName, formUniqueID, formTest
				}
			},
			/* [6] */
			"windows",
			cWindow,
			"Every window.",
			{	/* array Properties: 1 elements */
				/* [1] */
				"",
				kAESpecialClassProperties,
				cType,
				"",
				reserved,
				singleItem,
				notEnumerated,
				readOnly,
				reserved8,
				noApostrophe,
				notFeminine,
				notMasculine,
				plural,
			},
			{	/* array Elements: 0 elements */
			},
#endif
		},
		{	/* array ComparisonOps: 0 elements */
		},
		{	/* array Enumerations: 2 elements */
			enumViewType,
			{
				/* [1] */
				"frame",
				kAEODFrame,
				"",
				/* [2] */
				"large icon",
				kAEODLargeIcon,
				"",
				/* [3] */
				"small icon",
				kAEODSmallIcon,
				"",
				/* [4] */
				"thumbnail",
				kAEODThumbnail,
				""
			},
		},
	}
};


//-------------------------------------------------------------------------------------
// scsz resource for AppleScript
//-------------------------------------------------------------------------------------

resource 'scsz' (0) {
	readExtensionTerms,
	dontFindAppBySignature,
	alwaysSendSubject,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	reserved,
	8,
	8,
	8,
	368640,
	368640,
	368640
};


