/*
	File:		SEPriv.h

	Contains:	xxx put contents here xxx

	Owned by:	Nick Pilch

	Copyright:	 1995 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <6>	 9/11/95	NP		1272294: Messaging code cleanup.
		 <5>	 6/19/95	eeh		1246443: add PartFrameFromStandardPartToken
									etc.
		 <4>	 5/21/95	NP		1248898: GetUserToken, ODDescToAEDesc, etc.
									recipe change. Add SetUserODToken for
									setting user ODDesc in an OSLToken.
		 <3>	 4/25/95	NP		1186795, 1237220, 1240571: Fixed whose
									clauses by allowing swapping in count proc.
		 <2>	 4/25/95	JP		1237938: Move kODStandardPartTokenType to
									ODRgstry.xh
		 <1>	 4/14/95	NP		first checked in

	To Do:
*/

#ifndef _SEPRIV_
#define _SEPRIV_

#ifndef _CNTXTOSL_
#include "CntxtOSL.h"
#endif

#ifndef SOM_ODDesc_xh
#include "ODDesc.xh"
#endif

#if 0
struct SEUserTokenContents
{
	ODDesc		token;
	OSLContext	context;
};

StuffContextIntoToken(ODOSLToken* token, OSLContext* context);
OSLContext GetContextFromToken(ODOSLToken* token);
#endif /* 0 */


struct StandardPartToken
{
	ODFrame* fFrame;
	ODPart* fPart;
};
typedef struct StandardPartToken StandardPartToken, *StandardPartTokenPtr;

ODFrame* FrameFromStandardPartToken(AEDesc* token);
ODPart* PartFromStandardPartToken(AEDesc* token);
void	PartFrameFromStandardPartToken(AEDesc* token, ODPart** part,
		ODFrame** frame);
ODBoolean CanBeStandardPartToken( AEDesc* token );
OSErr CreateStandardPartToken( ODFrame* frame, ODPart* part, AEDesc* newToken );

ODFrame* GetDefaultRootFrameToSwapTo(Environment *ev, ODSession* session);

void SetUserODToken(OSLToken* oslToken, ODDesc* odDesc);

inline void MakeNULLDesc(AEDesc* desc)
{
	desc->descriptorType = typeNull;
	desc->dataHandle = NULL;
}

#endif /* _SEPRIV_ */