/*
	File:		TempSI.cpp

	Contains:	Utility for exception-safe temporary reference to ODSemanticInterface

	Owned by:	Jens Alfke

	Copyright:	 1995 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <1>	 6/22/95	jpa		first checked in

	Theory Of Operation:
		See the utility TempObj.h.
*/

#ifndef _TEMPSI_
#include "TempSI.h"
#endif

#ifndef _USE_TEMPLATES_

	#ifdef __MWERKS__
		// Make sure 'pragma once' mode is off so the .th files can be included
		// more than once!
		#pragma push
		#pragma once off
	#endif

	// Define the non-inline methods of the various template classes:

	#define _TMPL_IMPL_
	
	#define _T_		ODSemanticInterface
	#define _C_		TempODSemanticInterface
	#include "TempRef.th"

	#undef _TMPL_IMPL_

	#ifdef __MWERKS__
		#pragma pop
	#endif

#endif /*_USE_TEMPLATES_*/
