/*
	File:		SUClone.h

	Contains:	SUCloneHelper header

	Written by:	Vincent Lo

	Copyright:	 1995 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <1>	 1/26/95	VL		first checked in
	To Do:
	
*/

#ifndef _SUCLONE_
#define _SUCLONE_

#ifndef _ODTYPES_
#include <ODTypes.h>
#endif

#ifndef _ODMEMORY_
#include <ODMemory.h>
#endif

//==============================================================================
// Classes defined in this interface
//==============================================================================
class SUCloneHelper;

//==============================================================================
// Classes used by this interface
//==============================================================================
class ScopeIDList;

//==============================================================================
// SUCloneHelper
//==============================================================================
class SUCloneHelper
{
public:

	SUCloneHelper();
	
	~SUCloneHelper();
	
	ODBoolean ShouldClone(ODDraftKey key, ODID id);

private:

	ScopeIDList*	fScopeIDList;
	ODDraftKey		fKey;
	ODMemoryHeapID	fHeap;
	
	ODMemoryHeapID	GetHeap() {return fHeap;}
};

#endif	// _SUCLONE_