/*
	File:		SURef.h

	Contains:	SURefKeeper header

	Written by:	Vincent Lo

	Copyright:	 1995 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <1>	 1/26/95	VL		first checked in
	To Do:
	
*/

#ifndef _SUREF_
#define _SUREF_

#ifndef _ODTYPES_
#include <ODTypes.h>
#endif

#ifndef __CM_API__
#include <CMAPI.h>
#endif

//==============================================================================
// Classes defined in this interface
//==============================================================================
class SURefKeeper;

//==============================================================================
// Classes used by this interface
//==============================================================================
class CMStorageUnit;

class SURefKeeper
{
public:

	SURefKeeper(CMStorageUnit* su);
	
	~SURefKeeper();
	
	void Internalize();
	
	void Externalize();

	void GetNextSURef(ODStorageUnitRef ref, ODBoolean strong);
	
	void Reset(ODStorageUnitRef ref);
	
	ODBoolean IsWeakSURef(ODStorageUnitRef ref);
	
	ODBoolean IsStrongSURef(ODStorageUnitRef ref);
	
	void InvalidateSURef(ODStorageUnitRef ref);
	
	ODBoolean IsValidSURef(ODStorageUnitRef ref);

protected:

	CMStorageUnit*	fSU;
	ODBoolean		fDirty;
	ODULong			fCurrentSURef;
};


#endif // _SUREF_