/*
	File:		DgItmIt.cpp

	Contains:	Implementation of ODDragItemIterator

	Owned by:	Vincent Lo

	Copyright:	 1994 - 1995 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <5>	  8/3/95	RR		#1257260: Collapse B classes. Remove
									somInit methods. Don't call IsInitialized
									or SubclassResponsibility
		 <4>	 5/26/95	VL		1251403: Multithreading naming support.
		 <3>	 5/25/95	jpa		List.h --> LinkList.h [1253324]
		 <2>	 7/21/94	VL		Added implementation.

	To Do:
*/

#define ODDragItemIterator_Class_Source
#define VARIABLE_MACROS
#include <DgItmIt.xih>

#ifndef _DRAGPRIV_
#include <DragPriv.h>
#endif

#ifndef _LINKLIST_
#include <LinkList.h>
#endif

#include "DgItmItB.cpp"	// Platform-independent methods, if any

SOM_Scope void  SOMLINK ODDragItemIteratorInitDragItemIterator(ODDragItemIterator *somSelf, Environment *ev,
		LinkedListIterator* dragItemListIter)
{
    ODDragItemIteratorData *somThis = ODDragItemIteratorGetData(somSelf);
    ODDragItemIteratorMethodDebug("ODDragItemIterator","ODDragItemIteratorInitDragItemIterator");

	_fDragItemListIter = dragItemListIter;
}

SOM_Scope void  SOMLINK ODDragItemIteratorsomUninit(ODDragItemIterator *somSelf)
{
    ODDragItemIteratorData *somThis = ODDragItemIteratorGetData(somSelf);
    ODDragItemIteratorMethodDebug("ODDragItemIterator","ODDragItemIteratorsomUninit");

	delete _fDragItemListIter;
	
    ODDragItemIterator_parent_ODObject_somUninit(somSelf);
}

SOM_Scope ODStorageUnit*  SOMLINK ODDragItemIteratorFirst(ODDragItemIterator *somSelf, Environment *ev)
{
    ODDragItemIteratorData *somThis = ODDragItemIteratorGetData(somSelf);
    ODDragItemIteratorMethodDebug("ODDragItemIterator","ODDragItemIteratorFirst");

	ODDragLink*	theLink = (ODDragLink*) _fDragItemListIter->First();
	return(theLink ? (ODStorageUnit*) theLink->fItem->fSU : (ODStorageUnit*) kODNULL);
}

SOM_Scope ODStorageUnit*  SOMLINK ODDragItemIteratorNext(ODDragItemIterator *somSelf, Environment *ev)
{
    ODDragItemIteratorData *somThis = ODDragItemIteratorGetData(somSelf);
    ODDragItemIteratorMethodDebug("ODDragItemIterator","ODDragItemIteratorNext");

	ODDragLink *theLink = (ODDragLink*)_fDragItemListIter->Next();
	return(theLink ? (ODStorageUnit*) theLink->fItem->fSU : (ODStorageUnit*) kODNULL);
}

SOM_Scope ODBoolean  SOMLINK ODDragItemIteratorIsNotComplete(ODDragItemIterator *somSelf, Environment *ev)
{
    ODDragItemIteratorData *somThis = ODDragItemIteratorGetData(somSelf);
    ODDragItemIteratorMethodDebug("ODDragItemIterator","ODDragItemIteratorIsNotComplete");

	return (_fDragItemListIter->IsNotComplete());
}
