/*
	File:		SURefItr.cpp

	Contains:	Implementation of ODStorageUnitRefIterator

	Owned by:	Vincent Lo

	Copyright:	 1994 - 1995 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <5>	  8/3/95	RR		#1257260: Collapse B classes. Remove
									somInit methods. Don't call IsInitialized
									or SubclassResponsibility
		 <4>	 5/26/95	VL		1251403: Multithreading naming support.
		 <3>	 1/26/95	VL		#???: SURef is not a 4-byte array.
		 <2>	 9/26/94	VL		1185419: Added SubClassResponsibility to
									methods.
		 <1>	 6/28/94	VL		first checked in

	To Do:
*/

#define ODStorageUnitRefIterator_Class_Source
#include <SURefItr.xih>

SOM_Scope void  SOMLINK ODStorageUnitRefIteratorInitStorageUnitRefIterator(ODStorageUnitRefIterator *somSelf, Environment *ev,
		ODStorageUnit* storageUnit)
{
    /* ODStorageUnitRefIteratorData *somThis = ODStorageUnitRefIteratorGetData(somSelf); */
    ODStorageUnitRefIteratorMethodDebug("ODStorageUnitRefIterator","ODStorageUnitRefIteratorInitStorageUnitRefIterator");

}

SOM_Scope void  SOMLINK ODStorageUnitRefIteratorFirst(ODStorageUnitRefIterator *somSelf, Environment *ev,
	ODStorageUnitRef ref)
{
    /* ODStorageUnitRefIteratorData *somThis = ODStorageUnitRefIteratorGetData(somSelf); */
    ODStorageUnitRefIteratorMethodDebug("ODStorageUnitRefIterator","ODStorageUnitRefIteratorFirst");

	WARN("A subclass should have overridden this method!");
	ODSetSOMException(ev,kODErrSubClassResponsibility, "SubClass Responsibility");
}

SOM_Scope void  SOMLINK ODStorageUnitRefIteratorNext(ODStorageUnitRefIterator *somSelf, Environment *ev,
	ODStorageUnitRef ref)
{
    /* ODStorageUnitRefIteratorData *somThis = ODStorageUnitRefIteratorGetData(somSelf); */
    ODStorageUnitRefIteratorMethodDebug("ODStorageUnitRefIterator","ODStorageUnitRefIteratorNext");

	WARN("A subclass should have overridden this method!");
	ODSetSOMException(ev,kODErrSubClassResponsibility, "SubClass Responsibility");
}

SOM_Scope ODBoolean  SOMLINK ODStorageUnitRefIteratorIsNotComplete(ODStorageUnitRefIterator *somSelf, Environment *ev)
{
    /* ODStorageUnitRefIteratorData *somThis = ODStorageUnitRefIteratorGetData(somSelf); */
    ODStorageUnitRefIteratorMethodDebug("ODStorageUnitRefIterator","ODStorageUnitRefIteratorIsNotComplete");

	WARN("A subclass should have overridden this method!");
	ODSetSOMException(ev,kODErrSubClassResponsibility, "SubClass Responsibility");
	return kODTrue;
}

SOM_Scope void  SOMLINK ODStorageUnitRefIteratorsomUninit(ODStorageUnitRefIterator *somSelf)
{
    /* ODStorageUnitRefIteratorData *somThis = ODStorageUnitRefIteratorGetData(somSelf); */
    ODStorageUnitRefIteratorMethodDebug("ODStorageUnitRefIterator","ODStorageUnitRefIteratorsomUninit");

    ODStorageUnitRefIterator_parent_ODObject_somUninit(somSelf);
}
