/*
	File:		ODDesUtl.h

	Contains:	Interface for ODDesc<->AEDesc conversion utilities

	Owned by:	Nick Pilch

	Copyright:	 1995 by Apple Computer, Inc., all rights reserved.

	
*/

#ifndef _ODDESUTL_
#define _ODDESUTL_

#ifndef __APPLEVENTS__
#include <AppleEvents.h>
#endif

#ifndef _ODTYPESF_
#include "ODTypes.h"
#endif

#ifdef __cplusplus

class ODDesc;

#else

struct ODDesc;

#endif

#ifdef _OD_IMPL_SHARE_UTILS_
#pragma import on
#endif

#ifdef __cplusplus
extern "C" {
#endif

ODError ODDescToAEDesc(ODDesc* odDesc, AEDesc* aeDesc);
	// The ODDesc must be a valid object. AEDesc will be allocated by this call
	//	and should be disposed by the caller.
ODError AEDescToODDesc(AEDesc* aeDesc, ODDesc* odDesc);
	// The data in the AEDesc will be copied into the ODDesc. The AEDesc should
	//	be disposed by the caller. The ODDesc should be a valid instantiation,
	//	but can be empty.

//ODError AEDescChanged(AEDesc* aeDesc, ODDesc* odDesc);
	// Copies changed AEDesc back into ODDesc.

#ifdef __cplusplus
}
#endif

#ifdef _OD_IMPL_SHARE_UTILS_
#pragma import off
#endif

#endif /* _ODDESUTL_ */
