/*
	File:		ODNew.cpp

	Contains:	Implementation of a new operator for OpenDoc

	Owned by:	Nick Pilch

	Copyright:	 1993 - 1995 by Apple Computer, Inc., all rights reserved.

	
*/

#ifndef _ODNEW_
#include "ODNew.h"
#endif

#ifndef _ODMEMORY_
#include "ODMemory.h"
#endif

#ifndef __TYPES__
#include <Types.h>
#endif

#pragma segment ODNew

//==============================================================================
// Global new and delete operators
//==============================================================================

//------------------------------------------------------------------------------
// operator new
//------------------------------------------------------------------------------

void* operator new(size_t size)
{
	return ODNewPtr(size, kDefaultHeapID);
}

//------------------------------------------------------------------------------
// operator new
//------------------------------------------------------------------------------

void* operator new(size_t size, ODMemoryHeapID heap)
{
	return ODNewPtr(size, heap);
}

//------------------------------------------------------------------------------
// operator delete
//------------------------------------------------------------------------------

void operator delete(void* object)
{
	ODDisposePtr(object);
}

