/*
	File:		Util.r

	Contains:	resources for Info Utilties

	Owned by:	Tantek elik

	Copyright:	 1993 - 1995 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <9>	10/16/95	CC		GM 1292157: Changed "No Kinds" to
									"Unknown"; "None Available" to "None for
									this Kind".
		 <8>	 10/4/95	jpa		Include UtilCmmn.r [1285767]
		 <7>	 9/20/95	T		1285201 GM: Use
									alertPositionParentWindowScreen for dialogs
		 <6>	  9/5/95	JP		1250152: Center can't replace alert
									properly
		 <5>	 6/19/95	jpa		Removed "Arcane Info" button from SOM error
									dialog. [1258206]
		 <4>	 5/25/95	jpa		Added SOM error dialogs. [1253380]
		 <3>	  5/7/95	T		1221281 BB:Need to move No
		 <2>	 4/27/95	T		1223529 BB: ODSetPOName and ODSetIconFamily
									should tweak file in root part case (Did
									name piece)
		 <1>	 4/25/95	JP		first checked in

	To Do:
	In Progress:
		
*/

#define SystemSevenOrBetter 1			// we want the extended types
#define	SystemSevenOrLater	1			// Types.r uses this variable

#include "Types.r"

#include "UtilDefs.h"

#include "UtilCmmn.r"					// More resources

//-------------------------------------------------------------------------------------
// Strings
//-------------------------------------------------------------------------------------

resource 'STR ' (kODPartInfoStrUnknownID, purgeable) {
	"Unknown"
};

resource 'STR#' (kODInfoUtilStrsID, purgeable) {
	{
		 "Unknown"
		;"None for this Kind"
	}
};

//-------------------------------------------------------------------------------------
// Name conflict dialogs
//-------------------------------------------------------------------------------------

resource 'DLOG' (kNameConflictDlgID) {
	{40, 40, 142, 347},
	movableDBoxProc,
	invisible,
	noGoAway,
	0x0,
	kNameConflictDlgID,
	"Name Conflict",
	alertPositionParentWindowScreen
};

resource 'DITL' (kNameConflictDlgID) {
	{	/* array DITLarray: 3 elements */
		/* [1] kNameConflictCancelBtn */
		{68, 157, 88, 219},
		Button {
			enabled,
			"Cancel"
		},
		/* [2] kNameConflictReplaceBtn */
		{68, 233, 88, 295},
		Button {
			enabled,
			"Replace"
		},
		/* [3] kNameConflictTextItem */
		{10, 62, 58, 297},
		StaticText {
			disabled,
			"A document named \"^0\" already exists. Do"
			" you want to replace it?"
		},
		/* [4] kNameConflictDefaultButtonItem */
		{65, 154, 92, 222},
		UserItem {
			disabled
		},
		/* [5] */
		{10, 20, 42, 52},
		Icon {
			disabled,
			2
		}

	}
};


resource 'ALRT' (kFilelockedAlrtID) {
	{40, 40, 141, 389},
	kFilelockedAlrtID,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, sound1,
		/* [2] */
		OK, visible, sound1,
		/* [3] */
		OK, visible, sound1,
		/* [4] */
		OK, visible, sound1
	},
	alertPositionParentWindowScreen
};

resource 'DITL' (kFilelockedAlrtID) {
	{	/* array DITLarray: 2 elements */
		/* [1] */
		{68, 278, 88, 336},
		Button {
			enabled,
			"OK"
		},
		/* [2] */
		{10, 64, 59, 339},
		StaticText {
			disabled,
			"The existing document \"^0\" is locked or "
			"busy and cannot be replaced."
		},
		/* [3] */
		{65, 275, 91, 339},
		UserItem {
			disabled
		},
		/* [4] */
		{10, 20, 42, 52},
		Icon {
			disabled,
			0
		}
	}
};


resource 'ALRT' (kSOMErrorAlertID) {
	{40, 40, 142, 318},
	kSOMErrorAlertID,
	{	/* array: 4 elements */
		/* [1] */
		OK, visible, sound1,
		/* [2] */
		OK, visible, sound1,
		/* [3] */
		OK, visible, sound1,
		/* [4] */
		OK, visible, sound1
	},
	alertPositionParentWindowScreen
};

resource 'DITL' (kSOMErrorAlertID) {
	{	/* array DITLarray: 4 elements */
		/* [1] */
		{69, 201, 89, 263},
		Button {
			enabled,
			"Quit"
		},
		/* [2] */
/*		{69, 73, 89, 164},
		Button {
			enabled,
			"Arcane Info"
		},
*/		/* [3] */
		{10, 72, 58, 265},
		StaticText {
			disabled,
			"Sorry, this document must immediately"
			" quit due to a fatal SOM error."
		},
		/* [4] */
		{10, 20, 42, 52},
		Icon {
			disabled,
			0
		}
	}
};

resource 'DLOG' (kSOMErrorDlogID) {
	{40, 40, 220, 472},
	dBoxProc,
	invisible,
	noGoAway,
	0x0,
	kSOMErrorDlogID,
	"",
	alertPositionParentWindowScreen
};

resource 'DITL' (kSOMErrorDlogID) {
	{	/* array DITLarray: 4 elements */
		/* [1] */
		{148, 344, 168, 402},
		Button {
			enabled,
			"Quit"
		},
		/* [2] */
		{148, 262, 168, 320},
		Button {
			enabled,
			"Debug"
		},
		/* [3] */
		{8, 72, 135, 413},
		StaticText {
			disabled,
			""
		},
		/* [4] */
		{10, 20, 42, 52},
		Icon {
			disabled,
			0
		}
	}
};

data 'finf' (1004, purgeable) {
	$"0001 0003 0000 0009"                                /* ....... */
};

