/*
	File:		FragRsrc.h

	Contains:	Functions for using the resource fork of a code fragment

	Written by:	Jens Alfke

	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <1>	 1/25/95	jpa		first checked in
								 ---Moved to ODSOM:Interfaces:Handmade:
		 <2>	 1/12/95	jpa		Don't use obsolete Toolbox names [1211211]
		 <1>	10/24/94	jpa		first checked in

*/

#ifndef __FRAGRSRC__
#define __FRAGRSRC__

#ifndef __CODEFRAGMENTS__
#include <CodeFragments.h>
#endif


#ifdef __cplusplus
extern "C" {
#endif

#pragma lib_export on

typedef struct CFragResFile *CFragResFileRef;

OSErr	InitCFragResources( CFragInitBlockPtr, CFragResFileRef * );
OSErr	FSpInitCFragResources( const FSSpec *, CFragResFileRef * );
OSErr	TermCFragResources( CFragResFileRef );
OSErr	BeginCFragResources( CFragResFileRef );
OSErr	EndCFragResources( CFragResFileRef );

#pragma lib_export off

#ifdef __cplusplus
}
#endif

#endif /*__FRAGRSRC__*/
