/*
	File:		ODTypes.h

	Contains:	Central type-declaration header for OpenDoc

	Owned by:	Richard Rodseth

	Copyright:	 1994 - 1995 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <3>	  9/6/95	RR		#1231656 Moved constants to StdDef.idl
		 <2>	 2/14/95	jpa		Don't include ODTypesB.xh in non-C++ case!
									[1216470]
		 <1>	 1/25/95	jpa		first checked in
								 ---Moved to ODSOM:Interfaces:Handmade:
		 <4>	 1/13/95	RR		Include GeoTypes before ODTypesM.xh
		 <3>	 6/15/94	jpa		Moved ODTypesF.h before ODTypesM.xh.
		 <2>	 5/23/94	RR		Include GeoTypes and Polygon

	To Do:
	
	In Progress:
		
*/

/* This file is handmade, not generated from IDL. */

#ifndef _ODTYPES_
#define _ODTYPES_

#ifndef _ODTYPESF_
#include <ODTypesF.h>	
#endif

#ifdef __cplusplus

	#ifndef SOM_Module_OpenDoc_Global_TypesB_defined
	#include <ODTypesB.xh>
	#endif
	
	#ifndef SOM_Module_OpenDoc_GeoTypes_defined
	#include <GeoTypes.xh>	
	#endif
	
	#ifndef SOM_Module_OpenDoc_Global_Types_defined
	#include <ODTypesM.xh>
	#endif

	#ifndef SOM_Module_OpenDoc_StdDefs_defined
	#include <StdDefs.xh>
	#endif
	
	#ifndef SOM_Module_OpenDoc_Polygon_defined
	#include <Polygon.xh>	
	#endif

#else

	#ifndef SOM_Module_OpenDoc_Global_TypesB_defined
	#include <ODTypesB.h>
	#endif
	
	#ifndef SOM_Module_OpenDoc_GeoTypes_defined
	#include <GeoTypes.h>	
	#endif
	
	#ifndef SOM_Module_OpenDoc_Global_Types_defined
	#include <ODTypesM.h>
	#endif

	#ifndef SOM_Module_OpenDoc_StdDefs_defined
	#include <StdDefs.h>
	#endif
	
	#ifndef SOM_Module_OpenDoc_Polygon_defined
	#include <Polygon.h>	
	#endif
	
#endif

#endif // _ODTYPES_
