/*
	File:		ODTypesF.h

	Contains:	Definitions for Foreign types which can't be described in IDL

	Owned by:	Richard Rodseth

	Copyright:	 1994 - 1995 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <4>	  9/8/95	VL		1275241, 1283463: Added
									ODPlatformDragReference.
		 <3>	 5/25/95	jpa		Don't include GX header(s) [1253324]
		 <2>	 3/22/95	jpa		Added ODPlatformPrintJob. [1230236]
		 <1>	 1/25/95	jpa		first checked in
								 ---Moved to ODSOM:Interfaces:Handmade:
		<12>	 1/22/95	NP		Add ODHandle.
		<11>	11/30/94	RR		#1188078 Removed unused and inappropriate
																		types
		<10>	 9/23/94	RR		Removed forward declaration of ODPart
		 <9>	 8/18/94	T		#1181622 Set Richard to the Owned by:
									field
		 <8>	 7/26/94	eeh		remove typedef of ODQDPoint
		 <7>	 7/19/94	jpa		Include QDFixM.h.
		 <6>	 6/20/94	T		Added ODQDGlobalRec
		 <5>	 6/15/94	jpa		Added ODQDPoint definition.
		 <4>	 6/13/94	NP		Added comment after endif
		 <3>	  6/7/94	CG		Commented out def for GetIndString.
		 <2>	 5/23/94	RR		Added ODPlatformType
		 <2>	  4/4/94	RR		XMP -> OD
	
	In Progress:
		
*/

#ifndef _ODTYPESF_
#define _ODTYPESF_

/*
	This is a hand-made file, containing Macintosh "foreign" types, which cannot be defined in IDL. 
	Actually, all of them are 4-byte types which are defined in ODTypesM.idl as "unsigned long" 
	rather than as foreign, and are not emitted. This means that they can be marshalled, and 
	can be used without typecasting, since the actual definition is obtained from this file.
	
	This file is included in ODObject.h by way of  a "passThru" statement in ODObject.idl
*/


#ifndef __TYPES__
#include <Types.h>
#endif

#ifndef __FILES__
#include <Files.h>
#endif

#ifndef _QDFIXM_
#include <QDFixM.h>
/* 
	This header fixes problems with the incorrect use of the 'frame'
	constant defined in QuickDraw.h ... see comments in QDFixM.h for details.
*/
#endif

#ifndef __QUICKDRAW__
#include <QuickDraw.h>
#endif

#ifndef __WINDOWS__
#include <Windows.h>
#endif

#ifndef __MENUS__
#include <Menus.h>
#endif

#ifndef __AEREGISTRY__
#include <AERegistry.h>
#endif

#ifndef __APPLEEVENTS_
#include <AppleEvents.h>
#endif

#ifndef __EVENTS__
#include <Events.h>
#endif

#ifndef __FIXMATH__
#include <FixMath.h>			// Must include before GX headers...
#endif

#ifndef __DRAG__
#include <Drag.h>
#endif

//#ifndef __GXTYPES__
//#include <GXTypes.h>			/* for gxShape type */
//#endif

/* Definitions of 4-byte types defined in ODTypesM.idl, but not emitted */

typedef GrafPtr 		ODPlatformCanvas;	// But it's a gxViewPort for QuickDraw GX
typedef void*			ODPlatformPrintJob;
typedef	void*			ODPlatformShape;	// Graphics-system-dependent shape data
typedef void*			ODPlatformTransform;	// Graphics-system-dependent transform data
typedef RgnHandle		ODRgnHandle;
typedef struct gxPrivateShapeRecord *ODgxShape;	// Makes it synonymous with gxShape type
typedef WindowPtr    	ODPlatformWindow;
typedef MenuHandle		ODPlatformMenu;	
typedef Handle			ODPlatformMenuBar;
typedef OSType			ODOSType;
typedef ODOSType  		ODPlatformType;    // Host platform file & data type
typedef Handle  		ODHandle; 
typedef DragReference	ODPlatformDragReference;

#endif // _ODTYPESF_
