/*
	File:		ODTypes.r

	Contains:	OpenDoc Resource templates

	Owned by:	Caia Grisar

	Copyright:	 1993 - 1995 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <2>	10/25/95	TJ		#1292206 OLE Class Registry Resource
									Template
		 <1>	 8/24/95	TJ		first checked in
		 <1>	  6/8/95	RR		first checked in
		 <6>	 5/10/95	CG		#1243604	The constant kNameMappings renamed
									to kODNameMappings
		 <5>	 3/29/95	NP		1233490: Use Mac system constant for
									international text stuff.
		 <4>	 2/10/95	CG		#1177475: Added new 'nmap' type for
									Platform Space info.
		 <3>	  1/3/95	T		1191189 Eliminate duplicate Def.h, Def.xh
									files
		 <2>	10/19/94	CG		#1191532: Changed 'NMAP' to kNameMappings
		 <1>	 7/11/94	eeh		first checked in
		 <4>	  5/2/94	eeh		fix name of file in line 1 of comment
		 <3>	 1/21/94	CG		More NMAP changes.
		 <2>	 1/18/94	CG		New NMAP format!
		 <1>	11/17/93	CG		first checked in
	To Do:
*/

#ifndef __ODTYPES_R__
#define __ODTYPES_R__

#ifndef SystemSevenOrBetter
#define SystemSevenOrBetter 0
#endif

#ifndef SystemSevenOrLater					/* <19> KIP - Define to 0 if it is not defined */
#define SystemSevenOrLater 0
#endif

#ifndef SOM_Module_OpenDoc_StdDefs_defined
#include "StdDefs.r"
#endif

#ifndef __SYSTYPES_R__
#include "SysTypes.r"
#endif



/*----------------------------NMAP  NMAP Template-----------------------------------*/
type kODNameMappings {
	wstring;									/* NameSpace name */
	integer = $$Countof(KeyList);
	array KeyList {
		wstring;								/* A Key */
		switch {
			case kODIsMacOSType:
				key int = kODIsMacOSTypeID;
				literal longint;				/* an OSType */
			case kODIsINTLText:
				key int = kODIsINTLTextID;
				integer Script;					/* an international text struct */
				integer Language;
				wstring;
			case kODIsAnISOString:
				key int = kODIsAnISOStringID;
				wstring;						/* an ISOString */			
			case kODIsAnISOStringList:
				key int = kODIsAnISOStringListID;
				integer = $$Countof(ValueList);
				array ValueList {				/* an array of ISOStrings */
					wstring;				
				};
			case kODIsPltfmTypeSpac:
				key int = kODIsPltfmTypeSpacID;
				integer = $$Countof(PltfmTypeSpacList);
				array PltfmTypeSpacList {		/* an array of PlatformTypeSpaces */
					literal longint;			/* PlatformTypeSpace */	
					literal longint;			/* PlatformType */
					integer Script;				/* an international text struct */
					integer Language;
					wstring;
					wstring;					/* an ISOString */			
				};
			case kODIsHelpFileName:
				key int = kODIsHelpFileNameID;
				wstring;						/* Help file name */
		};		
	};
};

/*----------------------------OLE  OLE Class Registry Resource Template-----------------------------------*/

type 'olcr' {
      cstring;
};


#endif __ODTYPES_R__
